// MakeSHA384.cpp: CMakeSHA384 NX̃Cve[V
//
////////////////////////////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "MakeSHA384.h"


// AZułgꍇ1AgȂꍇ0
#define USE_ASSEMBLER 0

// SHA384 hinit  o͂nbV(h0`h5) ȊOSHA512ƑSASYł
void MakeSHA512Helper_c(const void *pBuffer, void *hash, DWORD len);
extern "C" void CDECL MakeSHA512Helper_asm(const void *pBuffer, void *hash, DWORD len);

static const QWORD hinit[] = {
    0xCBBB9D5DC1059ED8, 0x629A292A367CD507, 0x9159015A3070DD17, 0x152FECD8F70E5939,
    0x67332667FFC00B31, 0x8EB44A8768581511, 0xDB0C2E0D64F98FA7, 0x47B5481DBEFA4FA4
};



////////////////////////////////////////////////////////////////////////////////////////////////////

CMakeSHA384::CMakeSHA384()
{
    Initialize();
}

CMakeSHA384::~CMakeSHA384()
{
}

////////////////////////////////////////////////////////////////////////////////////////////////////

void CMakeSHA384::Initialize()
{
    CMakeHashAlgorithm::Initialize();
    memcpy(m_pHash, hinit, 64);
}

////////////////////////////////////////////////////////////////////////////////////////////////////

void CMakeSHA384::ComputeHashFinalHelper(void *msg_digest)
{
    BYTE buf[256], hash[64];
    DWORD len;
    QWORD string_bit_len;

    memcpy(hash, m_pHash, 64);

    len = m_dwRestLen;
    memcpy(buf, m_pRest, len);
    buf[len++] = 0x80;
    if ( len < 112 )
        memset(buf+len, 0, 112-len), len=112;
    else if ( len > 112 )
        memset(buf+len, 0, 240-len), len=240;
    string_bit_len = m_qwSrcLen * 8;
    memset(buf+len, 0, sizeof(QWORD));
    ReverseEndian64(buf+len+8, &string_bit_len, 8);
    len += 16;
    ComputeHashHelper(buf, hash, len);

    ReverseEndian64(msg_digest, hash, 48);
}

DWORD CMakeSHA384::ComputeHashHelper(const void *pBuffer, void *msg_digest, DWORD len)
{
#if (USE_ASSEMBLER==0)
    MakeSHA512Helper_c(pBuffer, msg_digest, len);
#else
    MakeSHA512Helper_asm(pBuffer, msg_digest, len);
#endif
    return len % 128;
}



////////////////////////////////////////////////////////////////////////////////////////////////////
// test

#ifdef HASH_TEST

void CMakeSHA384::Test()
{
    BYTE hash[48];

    static const char q1[] = "abc";
    static const char q2[] =
        "abcdefghbcdefghicdefghijdefghijkefghijklfghijklmghijklmnhijklmnoijklmnopjklmnopqklmnopqrlmnopqrsmnopqrstnopqrstu";

    static const QWORD a1[] = {
        0x8b5ea3453f7500cb, 0x0750c69a693da0b5, 0x63d1de0eab322c27,
        0xed5bff435a608b1a, 0x23cce7a12b078680, 0xa725c834a1ecba58 };
    static const QWORD a2[] = {
        0xe84711f7330c3309, 0x471bcd82c72f193d, 0xd2053b3b171b1153,
        0x12f7b0e38680a02f, 0xb92d7e551ac7c7fc, 0x39607491fae9c366 };
    static const QWORD a3[] = {
        0xcb74647109180e9d, 0x1c4a0a314e836e08, 0x5248f2009c9e14ed,
        0x5b2a4c70c5ce7279, 0xebc4ec38dcb3b807, 0x85893d7fd8dd97ae };


    Initialize();
    ComputeHash(q1, strlen(q1));
    GetHashValue(hash);
    ASSERT(memcmp(hash, a1, 48)==0);

    Initialize();
    ComputeHash(q2, strlen(q2));
    GetHashValue(hash);
    ASSERT(memcmp(hash, a2, 48)==0);

    Initialize();
    BYTE *pQ3=new BYTE[1000000];
    memset(pQ3, 'a', 1000000);
    ComputeHash(pQ3, 1000000);
    GetHashValue(hash);
    ASSERT(memcmp(hash, a3, 48)==0);
    delete [] pQ3;
}

#endif

