// MakeSHA384.h: CMakeSHA384 NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#pragma once

#include "MakeHashAlgorithm.h"

class CMakeSHA384 : public CMakeHashAlgorithm
{
public:
    CMakeSHA384();
    ~CMakeSHA384();

    virtual DWORD GetHashValueSize() { return 48; }
    virtual DWORD GetHashBlockSize() { return 128; }
    virtual void Initialize();

#ifdef HASH_TEST
    void Test();
#endif

private:
    virtual DWORD ComputeHashHelper(const void *pBuffer, DWORD len)
            { return ComputeHashHelper(pBuffer, m_pHash, len); }
    virtual DWORD ComputeHashHelper(const void *pBuffer, void *msg_digest, DWORD len);
    virtual void ComputeHashFinalHelper(void *msg_digest);

private:
    QWORD m_pHash[8];
};
