// MakeSHA512.h: CMakeSHA512 NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#pragma once

#include "MakeHashAlgorithm.h"

class CMakeSHA512 : public CMakeHashAlgorithm
{
public:
    CMakeSHA512();
    ~CMakeSHA512();

    virtual DWORD GetHashValueSize() { return 64; }
    virtual DWORD GetHashBlockSize() { return 128; }
    virtual void Initialize();

#ifdef HASH_TEST
    void Test();
#endif

private:
    virtual DWORD ComputeHashHelper(const void *pBuffer, DWORD len)
            { return ComputeHashHelper(pBuffer, m_pHash, len); }
    virtual DWORD ComputeHashHelper(const void *pBuffer, void *msg_digest, DWORD len);
    virtual void ComputeHashFinalHelper(void *msg_digest);

private:
    QWORD m_pHash[8];
};
