#include "stdafx.h"
#include <stdio.h>
#include <string.h>
#include "MakeCRC.h"
#include "MakeMD5.h"
#include "MakeSHA1.h"
#include "MakeSHA256.h"
#include "MakeSHA384.h"
#include "MakeSHA512.h"
#include "MakeRIPEMD128.h"
#include "MakeRIPEMD160.h"
#include "MakeRIPEMD256.h"
#include "MakeRIPEMD320.h"

// nbV̑xvꍇWindows.hCN[h(WindowsŐp)
#include "Windows.h"

void HashSpeed();
void HashTest();


void main(int argc, char *argv[])
{
    FILE *pFile;
    size_t size;
    char buf[32*1024];
    CMakeMD5 md5;


#ifdef HASH_TEST
    HashTest();
#endif


    if ( argc == 1 )
        return;

    // R}hC /s /S w肳Ăꍇ́AnbVx𑪒
    if ( strcmp(argv[1],"/s")==0 || strcmp(argv[1],"/S")==0 ) {
        HashSpeed();
        return;
    }

    pFile = fopen(argv[1], "rb");
    if ( pFile == NULL ) {
        printf("t@COpenł܂\n");
        return;
    }

    // 32*102432KB
    // nbVvZƂ͂ł邾2̏搔oCg
    // iGetHashBlockSize()̔{łjɂ邱
    // ȂƌvZxxȂ܂
    size = fread(buf, 1, 32*1024, pFile);
    while ( size > 0 ) {
        md5.ComputeHash(buf, size);
        size = fread(buf, 1, 32*1024, pFile);
    }
    fclose(pFile);
    md5.GetHashString(buf, TRUE);
    printf("MD5sum = %s\n", buf);
}


#ifdef HASH_TEST
void HashTest()
{
    CMakeCRC16 crc16;
    CMakeCRC32 crc32;
    CMakeMD5 md5;
    CMakeSHA1 sha1;
    CMakeSHA256 sha256;
    CMakeSHA384 sha384;
    CMakeSHA512 sha512;
    CMakeRIPEMD128 rmd128;
    CMakeRIPEMD160 rmd160;
    CMakeRIPEMD256 rmd256;
    CMakeRIPEMD320 rmd320;

    crc16.Test();
    crc32.Test();
    md5.Test();
    sha1.Test();
    sha256.Test();
    sha384.Test();
    sha512.Test();
    rmd128.Test();
    rmd160.Test();
    rmd256.Test();
    rmd320.Test();
}
#endif  // HASH_TEST


void HashSpeed()
{
// nbVvZ鑬x𑪒
// ̑֐Windowspł
// WindowsȊȌꍇ̓^C}KXύXĂ

    CMakeCRC16 crc16;
    CMakeCRC32 crc32;
    CMakeMD5 md5;
    CMakeSHA1 sha1;
    CMakeSHA256 sha256;
    CMakeSHA384 sha384;
    CMakeSHA512 sha512;
    CMakeRIPEMD128 rmd128;
    CMakeRIPEMD160 rmd160;
    CMakeRIPEMD256 rmd256;
    CMakeRIPEMD320 rmd320;
    CMakeHashAlgorithm *pHash[] = { &crc16, &crc32, &md5, &sha1, &sha256, &sha384, &sha512,
                                    &rmd128, &rmd160, &rmd256, &rmd320, NULL };
    char *hash_name[] = { "CRC16", "CRC32", "MD5", "SHA1", "SHA256", "SHA384", "SHA512",
                          "RIPEMD128", "RIPEMD160", "RIPEMD256", "RIPEMD320"};

    __int64 start_time, end_time, freq_time, mbps, ms, hash_time[32];
    DWORD hash_cmp;
    int i;
    BYTE *pBuffer, hashbuf[128];

    // ^C}̕\擾
    BOOL ok=QueryPerformanceFrequency((LARGE_INTEGER*)&freq_time);
    if ( !ok ) {
        printf("Timer̍쐬Ɏs܂\n");
        return;
    }

    // 10MB̃obt@쐬
    pBuffer = new BYTE[10*1024*1024];
    memset(pBuffer, 0, 10*1024*1024);

    // vZX̗Dxōɂ
#ifdef _DEBUG
    ::SetPriorityClass(GetCurrentProcess(), HIGH_PRIORITY_CLASS);
#else
    ::SetPriorityClass(GetCurrentProcess(), REALTIME_PRIORITY_CLASS);
#endif

    i = 0;
    while ( pHash[i] ) {
        pHash[i]->ComputeHash(pBuffer, 10*1024*1024);
        pHash[i]->GetHashValue(hashbuf);
        pHash[i]->Initialize();
        QueryPerformanceCounter((LARGE_INTEGER*)&start_time);
        pHash[i]->ComputeHash(pBuffer, 10*1024*1024);
        pHash[i]->GetHashValue(hashbuf);
        QueryPerformanceCounter((LARGE_INTEGER*)&end_time);
        hash_time[i] = end_time - start_time;
        ms = (hash_time[i]*10000) / freq_time;
        mbps = ((__int64)(10*1024*1024)*freq_time) / hash_time[i];
        printf("%s : %.1fMB/s  [%.1fms]\n", hash_name[i], ((double)mbps)/(1024*1024), ((double)ms)/10);
        i++;
    }

    printf("\nr (sec)\n");
    i = 0;
    while ( pHash[i] ) {
        hash_cmp = (DWORD)((hash_time[i]*100)/hash_time[0]);
        if ( pHash[i+1] )
            printf("%u : ", hash_cmp);
        else
            printf("%u\n", hash_cmp);
        i++;
    }

    printf("\nr (MB/s)\n");
    i = 0;
    while ( pHash[i] ) {
        hash_cmp = (DWORD)((hash_time[0]*100)/hash_time[i]);
        if ( pHash[i+1] )
            printf("%u : ", hash_cmp);
        else
            printf("%u\n", hash_cmp);
        i++;
    }

    delete [] pBuffer;
    ::SetPriorityClass(GetCurrentProcess(), NORMAL_PRIORITY_CLASS);
}

